net.i2p.data.i2np

## Class DeliveryStatusMessage

- java.lang.Object
- - net.i2p.data.i2np.I2NPMessageImpl
  - - net.i2p.data.i2np.FastI2NPMessageImpl
    - - net.i2p.data.i2np.DeliveryStatusMessage

- All Implemented Interfaces:
    I2NPMessage

      public class DeliveryStatusMessage
      extends FastI2NPMessageImpl

  Defines the message sent back in reply to a message when requested, containing the private ack id.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.i2p.data.i2np.I2NPMessageImpl

      `I2NPMessageImpl.Builder`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `MESSAGE_TYPE`

    - ### Fields inherited from class net.i2p.data.i2np.FastI2NPMessageImpl

      `_checksum, _hasChecksum`

    - ### Fields inherited from class net.i2p.data.i2np.I2NPMessageImpl

      `_context, _expiration, _log, CHECKSUM_LENGTH, DEFAULT_EXPIRATION_MS, HEADER_LENGTH`

    - ### Fields inherited from interface net.i2p.data.i2np.I2NPMessage

      `MAX_ID_VALUE, MAX_SIZE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DeliveryStatusMessage(I2PAppContext context)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected int` | `calculateWrittenLength()` calculate the message body's length (not including the header and footer
    `boolean` | `equals(Object object)`
    `long` | `getArrival()` Misnamed, as it is generally (always?) set by the creator to the current time, in some future usage it could be set on arrival
    `long` | `getMessageId()`
    `int` | `getType()` Return the unique identifier for this type of I2NP message, as defined in the I2NP spec
    `int` | `hashCode()`
    `void` | `readMessage(byte[] data, int offset, int dataSize, int type)` Read the body into the data structures, after the initial type byte and the uniqueId / expiration, using the current class's format as defined by the I2NP specification
    `void` | `setArrival(long arrival)` Misnamed, as it is generally (always?) set by the creator to the current time, in some future usage it could be set on arrival
    `void` | `setMessageId(long id)`
    `String` | `toString()`
    `protected int` | `writeMessageBody(byte[] out, int curIndex)` write the message body to the output array, starting at the given index

    - ### Methods inherited from class net.i2p.data.i2np.FastI2NPMessageImpl

      `readBytes, toByteArray, toByteArrayWithSavedChecksum`

    - ### Methods inherited from class net.i2p.data.i2np.I2NPMessageImpl

      `createMessage, fromRawByteArray, fromRawByteArrayNTCP2, getMessageExpiration, getMessageSize, getRawMessageSize, getUniqueId, getUniqueId, readBytes, readMessage, setMessageExpiration, setUniqueId, toByteArray, toByteArray, toRawByteArray, toRawByteArrayNTCP2`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### MESSAGE_TYPE

          public static final int MESSAGE_TYPE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DeliveryStatusMessage

          public DeliveryStatusMessage(I2PAppContext context)

  - ### Method Detail

    - #### calculateWrittenLength

          protected int calculateWrittenLength()

      calculate the message body's length (not including the header and footer
      Specified by:
        `calculateWrittenLength` in class `I2NPMessageImpl`

    - #### equals

          public boolean equals(Object object)

      Overrides:
        `equals` in class `Object`

    - #### getArrival

          public long getArrival()

      Misnamed, as it is generally (always?) set by the creator to the current time, in some future usage it could be set on arrival

    - #### getMessageId

          public long getMessageId()

    - #### getType

          public int getType()

      Description copied from interface: `I2NPMessage`
      Return the unique identifier for this type of I2NP message, as defined in the I2NP spec

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### readMessage

          public void readMessage(byte[] data,
                                  int offset,
                                  int dataSize,
                                  int type)
                           throws I2NPMessageException

      Description copied from interface: `I2NPMessage`
      Read the body into the data structures, after the initial type byte and the uniqueId / expiration, using the current class's format as defined by the I2NP specification
      Parameters:
        `data` - data to read from
        `offset` - where to start in the data array
        `dataSize` - how long into the data to read
        `type` - I2NP message type
      Throws:
        `I2NPMessageException` - if the stream doesn't contain a valid message that this class can read.

    - #### setArrival

          public void setArrival(long arrival)

      Misnamed, as it is generally (always?) set by the creator to the current time, in some future usage it could be set on arrival

    - #### setMessageId

          public void setMessageId(long id)

      Parameters:
        `id` - 0 to (2**32) - 1
      Throws:
        `IllegalStateException` - if id previously set, to protect saved checksum
        `IllegalArgumentException`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### writeMessageBody

          protected int writeMessageBody(byte[] out,
                                         int curIndex)
                                  throws I2NPMessageException

      write the message body to the output array, starting at the given index
      Specified by:
        `writeMessageBody` in class `I2NPMessageImpl`
      Returns:
        the index into the array after the last byte written (NOT the length)
      Throws:
        `I2NPMessageException`